export declare enum SfuEvent {
    CONNECTED = "CONNECTED",
    FAILED = "FAILED",
    DISCONNECTED = "DISCONNECTED",
    MESSAGE = "MESSAGE",
    USER_LIST = "USER_LIST",
    USER_CHATS = "USER_CHATS",
    CHAT_LOADED = "CHAT_LOADED",
    NEW_CHAT = "NEW_CHAT",
    CHAT_DELETED = "CHAT_DELETED",
    CHAT_UPDATED = "CHAT_UPDATED",
    MESSAGE_STATE = "MESSAGE_STATE",
    CONTACT_UPDATE = "CONTACT_UPDATE",
    CONTACT_REMOVED = "CONTACT_REMOVED",
    CONTACT_INVITE = "CONTACT_INVITE",
    PUBLIC_CHANNELS = "PUBLIC_CHANNELS",
    USER_CALENDAR = "USER_CALENDAR",
    NEW_CALENDAR_ENTRY = "NEW_CALENDAR_ENTRY",
    REMOVE_CALENDAR_ENTRY = "REMOVE_CALENDAR_ENTRY",
    UPDATE_CALENDAR_EVENT = "UPDATE_CALENDAR_EVENT",
    ACK = "ACK",
    ATTACHMENT_DATA = "ATTACHMENT_DATA",
    USER_ROOMS = "USER_ROOMS",
    ATTACHMENT = "ATTACHMENT"
}
export declare enum RoomEvent {
    CREATED = "CREATED",
    ENDED = "ENDED",
    AVAILABLE = "AVAILABLE",
    FAILED = "FAILED",
    ADD_TRACKS = "ADD_TRACKS",
    REMOVE_TRACKS = "REMOVE_TRACKS",
    MESSAGE = "MESSAGE",
    CONTROL_MESSAGE = "CONTROL_MESSAGE",
    JOINED = "JOINED",
    LEFT = "LEFT",
    DETACHED = "DETACHED",
    EVICTED = "EVICTED",
    REMOTE_SDP = "REMOTE_SDP",
    TRACK_QUALITY_STATE = "TRACK_QUALITY_STATE",
    OPERATION_FAILED = "OPERATION_FAILED",
    WAITING_LIST = "SFU_WAITING_LIST",
    WAITING_ROOM_UPDATE = "SFU_WAITING_ROOM_UPDATE",
    MUTE_TRACKS = "MUTE_TRACKS",
    PARTICIPANT_LIST = "PARTICIPANT_LIST",
    ROLE_ASSIGNED = "ROLE_ASSIGNED",
    ROLES_LIST = "ROLES_LIST"
}
export declare enum State {
    NEW = "NEW",
    PENDING = "PENDING",
    CONNECTED = "CONNECTED",
    AUTHENTICATED = "AUTHENTICATED",
    DISCONNECTED = "DISCONNECTED",
    FAILED = "FAILED"
}
export declare enum RoomState {
    NEW = "NEW",
    PENDING = "PENDING",
    JOINED = "JOINED",
    FAILED = "FAILED",
    DISPOSED = "DISPOSED"
}
export declare enum Operations {
    ROOM_CREATE = "ROOM_CREATE",
    ROOM_JOIN = "ROOM_JOIN",
    ROOM_AVAILABLE = "ROOM_AVAILABLE",
    ROOM_DESTROY = "ROOM_DESTROY",
    SEND_MESSAGE = "SEND_MESSAGE",
    USER_LIST = "USER_LIST",
    USER_CALENDAR = "USER_CALENDAR",
    ADD_CALENDAR_EVENT = "ADD_CALENDAR_EVENT",
    REMOVE_CALENDAR_EVENT = "REMOVE_CALENDAR_EVENT",
    UPDATE_CALENDAR_EVENT = "UPDATE_CALENDAR_EVENT",
    ROOM_UPDATE = "ROOM_UPDATE",
    MUTE_TRACKS = "MUTE_TRACKS",
    ASSIGN_ROLE = "ASSIGN_ROLE",
    SUBSCRIBE_TO_WAITING_PARTICIPANT = "SUBSCRIBE_TO_WAITING_PARTICIPANT",
    UNSUBSCRIBE_FROM_WAITING_PARTICIPANT = "UNSUBSCRIBE_FROM_WAITING_PARTICIPANT",
    MOVE_TO_WAITING_ROOM = "MOVE_TO_WAITING_ROOM",
    CREATE_CHAT = "CREATE_CHAT",
    DELETE_CHAT = "DELETE_CHAT",
    RENAME_CHAT = "RENAME_CHAT",
    LOAD_CHAT = "LOAD_CHAT",
    ADD_MEMBER_TO_CHAT = "ADD_MEMBER_TO_CHAT",
    REMOVE_MEMBER_FROM_CHAT = "REMOVE_MEMBER_FROM_CHAT",
    UPDATE_CHAT_PREFERENCES = "UPDATE_CHAT_PREFERENCES",
    GET_USER_CHATS = "GET_USER_CHATS",
    UPDATE_CHAT_CONFIGURATION = "UPDATE_CHAT_CONFIGURATION",
    GET_ACTIVE_ROOMS = "GET_ACTIVE_ROOMS",
    ROOM_EXISTS = "ROOM_EXISTS"
}
export declare enum ParticipantRole {
    OWNER = "OWNER",
    ADMIN = "ADMIN",
    PARTICIPANT = "PARTICIPANT"
}
export declare enum TrackType {
    AUDIO = "AUDIO",
    VIDEO = "VIDEO"
}
export declare enum InternalApi {
    Z_APP = "sfuZClientApp",
    P_APP = "sfuApp",
    DEFAULT_METHOD = "sfuCallback",
    BINARY_DATA = "binaryData",
    JOIN_ROOM = "joinRoom",
    CREATE_ROOM = "createRoom",
    ROOM_AVAILABLE = "roomAvailable",
    ROOM_EXISTS = "roomExists",
    UPDATE_ROOM_STATE = "updateRoomState",
    DESTROY_ROOM = "destroyRoom",
    LEAVE_ROOM = "leaveRoom",
    CHANGE_QUALITY = "changeQuality",
    AUTHORIZE_WAITING_LIST = "authorizeWaitingList",
    MESSAGE = "SFU_MESSAGE",
    MESSAGE_STATE = "SFU_MESSAGE_STATE",
    SFU_ATTACHMENT_REQUEST_ACK = "SFU_ATTACHMENT_REQUEST_ACK",
    USER_LIST = "SFU_USER_LIST",
    USER_CALENDAR = "SFU_USER_CALENDAR",
    USER_CHATS = "SFU_USER_CHATS",
    PUBLIC_CHANNELS = "SFU_PUBLIC_CHANNELS",
    CHAT_LOADED = "SFU_CHAT_LOADED",
    NEW_CHAT = "SFU_NEW_CHAT",
    CHAT_DELETED = "SFU_CHAT_DELETED",
    CHAT_UPDATED = "SFU_UPDATE_CHAT",
    CONTACT_UPDATED = "SFU_CONTACT_UPDATE",
    CONTACT_INVITE = "SFU_CONTACT_INVITE",
    CONTACT_REMOVED = "SFU_CONTACT_REMOVED",
    GET_USER_LIST = "getUserList",
    GET_USER_CALENDAR = "getUserCalendar",
    ADD_CALENDAR_EVENT = "addCalendarEvent",
    REMOVE_CALENDAR_EVENT = "removeCalendarEvent",
    UPDATE_CALENDAR_EVENT = "updateCalendarEvent",
    CREATE_ROOM_FROM_EVENT = "createRoomFromEvent",
    MUTE_TRACK = "muteTrack",
    SEND_MESSAGE = "sendMessage",
    GET_ATTACHMENT = "loadAttachment",
    SEND_CONTROL_MESSAGE = "sendControlMessage",
    MARK_MESSAGE_READ = "markMessageRead",
    MARK_MESSAGE_UNREAD = "markMessageUnread",
    INVITE_CONTACT = "inviteContact",
    REMOVE_CONTACT = "removeContact",
    CONFIRM_CONTACT = "confirmContact",
    ASSIGN_ROLE = "assignRole",
    SUBSCRIBE_TO_WAITING_PARTICIPANT = "subscribeToWaitingParticipant",
    UNSUBSCRIBE_FROM_WAITING_PARTICIPANT = "unsubscribeFromWaitingParticipant",
    MOVE_TO_WAITING_ROOM = "moveToWaitingRoom",
    CONFIGURE_WAITING_ROOM = "configureWaitingRoom",
    TRACK_CONTENT_HEADER = "a=content =",
    GET_USER_CHATS = "getUserChats",
    GET_PUBLIC_CHANNELS = "getPublicChannels",
    LOAD_CHAT = "loadChat",
    CREATE_CHAT = "createChat",
    DELETE_CHAT = "deleteChat",
    RENAME_CHAT = "renameChat",
    ADD_MEMBER_TO_CHAT = "addMemberToChat",
    REMOVE_MEMBER_FROM_CHAT = "removeMemberFromChat",
    UPDATE_CHANNEL_SEND_POLICY = "updateChannelSendPolicy",
    ADD_CHANNEL_SEND_PERMISSION_LIST_MEMBER = "addChannelSendPermissionListMember",
    REMOVE_CHANNEL_SEND_PERMISSION_LIST_MEMBER = "removeChannelSendPermissionListMember",
    UPDATE_CHAT_CONFIGURATION = "updateChatConfiguration",
    ADD_CHAT_TO_FAVOURITES = "addChatToFavourites",
    REMOVE_CHAT_FROM_FAVOURITES = "removeChatFromFavourites",
    ADD_CONTACT_TO_FAVOURITES = "addContactToFavourites",
    REMOVE_CONTACT_FROM_FAVOURITES = "removeContactFromFavourites",
    GET_ACTIVE_ROOMS = "getActiveRooms"
}
export declare enum RoomError {
    AUTHORIZATION_FAILED = "Authorization failed by owner",
    ROOM_DESTROYED = "Room destroyed",
    WRONG_PIN = "Wrong pin",
    NOT_FOUND = "Room not found",
    NICKNAME_UNAVAILABLE = "Nickname unavailable"
}
export declare const ATTACHMENT_CHUNK_SIZE = 100000;
export declare type InternalMessage = {
    type: SfuEvent | RoomEvent | InternalApi;
    roomId: string;
    internalMessageId: string;
};
export declare type OperationFailed = InternalMessage & {
    operation: Operations;
    error: string;
    info: any;
};
export declare type RoomMessage = InternalMessage & {
    message: {
        nickName: UserNickname;
        message: string;
    };
};
export declare type FragmentedMessage = {
    id: string;
    last: boolean;
    payload: string;
};
export declare enum RemoteSdpType {
    OFFER = "offer",
    ANSWER = "answer"
}
export declare type RemoteSdp = InternalMessage & {
    info: {
        sdp: string;
        type: RemoteSdpType;
    };
};
export declare type RoleAssigned = InternalMessage & {
    name: UserNickname;
    role: ParticipantRole;
};
export declare type RolesListEvent = InternalMessage & {
    roles: Array<{
        name: UserNickname;
        role: ParticipantRole;
    }>;
};
export declare type CreatedRoom = InternalMessage & {
    name: string;
    pin: string;
    inviteId: string;
    creationTime: number;
};
export declare type RoomInfo = {
    id: string;
    name: string;
    pin: string;
    creationTime: number;
};
export declare type UserRoomsEvent = InternalMessage & {
    rooms: Array<RoomInfo>;
};
export declare type RoomAvailable = InternalMessage & {
    name: string;
    pin: string;
    creationTime: number;
};
export declare type JoinedRoom = InternalMessage & {
    name: UserNickname;
};
export declare type LeftRoom = InternalMessage & {
    name: UserNickname;
};
export declare type EvictedFromRoom = InternalMessage & {
    name: UserNickname;
};
export declare type ParticipantsListEvent = InternalMessage & {
    participants: Array<UserNickname>;
};
export declare type WaitingListEvent = InternalMessage & {
    users: Array<User>;
};
export declare type AddRemoveTracks = InternalMessage & {
    info: {
        nickName: UserNickname;
        waitingRoom: boolean;
        info: Array<{
            id: string;
            type: TrackType;
            contentType: string;
            mid: string;
            quality: Array<string>;
            mute: boolean;
        }>;
    };
};
export declare type WaitingRoomUpdate = InternalMessage & {
    enabled: boolean;
};
export declare enum MessageState {
    NO_DELIVERY_NO_READ = "NO_DELIVERY_NO_READ",
    PARTIAL_DELIVERY_NO_READ = "PARTIAL_DELIVERY_NO_READ",
    PARTIAL_DELIVERY_PARTIAL_READ = "PARTIAL_DELIVERY_PARTIAL_READ",
    FULL_DELIVERY_NO_READ = "FULL_DELIVERY_NO_READ",
    FULL_DELIVERY_PARTIAL_READ = "FULL_DELIVERY_PARTIAL_READ",
    FULL_DELIVERY_FULL_READ = "FULL_DELIVERY_FULL_READ",
    PENDING_ATTACHMENTS = "PENDING_ATTACHMENTS"
}
export declare enum DeliveryStatus {
    PENDING = "PENDING",
    DELIVERED = "DELIVERED",
    READ = "READ",
    UNREAD = "UNREAD"
}
export declare type MessageDeliveryStatus = {
    [key: UserId]: DeliveryStatus;
};
export declare type MessageStatus = {
    id: string;
    chatId: string;
    delivered: boolean;
    state: MessageState;
    lastReadMessageId: string;
    info: string;
    date: number;
    attachments: Array<MessageAttachment>;
    deliveryStatus: MessageDeliveryStatus;
};
export declare enum MessageAttachmentType {
    file = "file",
    picture = "picture"
}
export declare type MessageAttachment = {
    type: MessageAttachmentType;
    name: string;
    size: number;
    id: number;
};
export declare type MessageAttachmentData = {
    size: number;
    payload: ArrayBuffer;
    id: number;
};
export declare type AttachmentRequest = {
    chatId: string;
    messageId: string;
    attachmentId: number;
    name: string;
    tmpId?: number;
};
export declare type Attachment = AttachmentRequest & {
    internalMessageId: string;
    payload: ArrayBuffer;
};
export declare type AttachmentRequestAck = InternalMessage & {
    attachmentRequest: AttachmentRequest;
};
export declare type Message = {
    id: string;
    chatId: string;
    date: number;
    from: UserId;
    to?: UserId;
    status: MessageState;
    body: string;
    attachments: Array<MessageAttachment>;
    deliveryStatus: MessageDeliveryStatus;
};
export declare type SfuMessageEvent = InternalMessage & {
    message: Message;
};
export declare type MessageStatusEvent = InternalMessage & {
    status: MessageStatus;
};
export declare type ControlMessage = {
    from: UserNickname;
    to: UserNickname;
    body: string;
    broadcast: boolean;
};
export declare type ControlMessageEvent = InternalMessage & {
    message: ControlMessage;
};
export declare enum UserState {
    OFFLINE = "OFFLINE",
    ONLINE = "ONLINE",
    PENDING_REGISTRATION = "PENDING_REGISTRATION"
}
export declare type Invite = InternalMessage & {
    id: string;
    from: UserId;
    to: UserId | UserEmail;
};
export declare type User = {
    state: UserState;
    id: UserId;
    email: UserEmail;
    nickname: UserNickname;
    confirmed: boolean;
    favourite: boolean;
    invite: Invite;
};
export declare type UserListEvent = InternalMessage & {
    list: Array<User>;
};
export declare type ContactInviteEvent = InternalMessage & {
    invite: Invite;
};
export declare type ContactUpdateEvent = InternalMessage & {
    contact: User;
};
export declare type ContactRemovedEvent = InternalMessage & {
    contact: User;
};
export declare type CalendarEvent = {
    id: string;
    accessCode?: string;
    description: string;
    title: string;
    start: number;
    end: number;
    ownerVideo: boolean;
    participantVideo: boolean;
    recurring: boolean;
    usePMI: boolean;
    waitingRoom: boolean;
};
export declare type Calendar = {
    events: Array<CalendarEvent>;
};
export declare type UserCalendarEvent = InternalMessage & {
    calendar: Calendar;
};
export declare type CalendarEventEvent = InternalMessage & {
    entry: CalendarEvent;
};
export declare type UserSpecificChatInfo = {
    id: string;
    favourite: boolean;
    channel: boolean;
    name: string;
    owner: UserId;
    members: Array<UserId>;
    lastReadMessageId: string;
    canSend: boolean;
    channelType: ChannelType;
    channelSendPolicy: ChannelSendPolicy;
    sendPermissionList: Array<string>;
    allowedToAddExternalUser: boolean;
};
export declare enum ChannelType {
    PUBLIC = "PUBLIC",
    PRIVATE = "PRIVATE"
}
export declare enum ChannelSendPolicy {
    EVERYONE = "EVERYONE",
    ADMIN = "ADMIN",
    ADMIN_AND_LIST = "ADMIN_AND_LIST"
}
export declare type Chat = {
    id: string;
    name: string;
    owner: UserId;
    member: UserId;
    favourite: boolean;
    members: Array<UserId>;
    messages: Array<Message>;
    channel: boolean;
    channelType: ChannelType;
    channelSendPolicy: ChannelSendPolicy;
    sendPermissionList: Array<string>;
    allowedToAddExternalUser: boolean;
};
export declare type NewChatEvent = InternalMessage & {
    info: UserSpecificChatInfo;
};
export declare type RemovedChatEvent = InternalMessage & {
    info: UserSpecificChatInfo;
};
export declare type UpdateChatEvent = InternalMessage & {
    info: UserSpecificChatInfo;
};
export declare type ChatMap = {
    [key: string]: UserSpecificChatInfo;
};
export declare type ChatsEvent = InternalMessage & {
    chats: ChatMap;
};
export declare type PublicChannelsEvent = InternalMessage & {
    channels: ChatMap;
};
export declare type ChatLoadedEvent = InternalMessage & {
    chat: Chat;
};
export declare type OperationFailedEvent = InternalMessage & {
    operation: Operations;
    error: string;
    info: any;
};
export declare type UserId = string;
export declare type UserNickname = string;
export declare type UserEmail = string;
