import { Room } from "./room";
import { Connection } from "./connection";
import { AddRemoveTracks, CreatedRoom, ParticipantRole, UserId, UserNickname, WaitingRoomUpdate } from "./constants";
export declare class RoomExtended extends Room {
    constructor(connection: Connection, id: string, name: string, pin: string, nickname: UserNickname, creationTime: number);
    createRoom(): Promise<CreatedRoom>;
    sendControlMessage(msg: string, broadcast: boolean, to?: UserNickname): Promise<void>;
    authorizeWaitingList(userId: UserId, authorized: boolean): Promise<void>;
    moveToWaitingRoom(nickname: UserNickname): Promise<void>;
    configureWaitingRoom(enabled: boolean): Promise<WaitingRoomUpdate>;
    assignRole(nickname: UserNickname, role: ParticipantRole): Promise<void>;
    subscribeToWaitingParticipant(nickname: UserNickname): Promise<AddRemoveTracks>;
    unsubscribeFromWaitingParticipant(nickname: UserNickname): Promise<AddRemoveTracks>;
}
